#ifndef GAME_H
#define GAME_H

//#define USE_GRAPHIC_YOU_WIN//Use a static "You Win!!!" image instead of the animated one
#define MOVEMENT_WRAPS//When you go left from the left most you are on the right; same with all directions

extern "C"
{
	#include <os.h>
	#include "SDL/SDL.h"
	#include "HitoriLib/HitoriLib.h"
}

#ifndef USE_GRAPHIC_YOU_WIN
#include "YouWinMessage.h"
#endif

#include "Config.h"
#include "Defines.h"

enum Direction{Up, Down, Left, Right};

class Game
{
public:
	Game(SDL_Surface* pScreen, const char* pstrFile, int nLevelNumber, Config* pConfig);
	~Game();

	bool Loop();
	
protected:
	bool PollEvents();
	void UpdateDisplay();
	void Move(Direction eDirection);
	void ToggleMarking();
	bool IsAdjacentMarked(int nX, int nY);
	bool IsMaybeMarked(int nX, int nY);
	bool IsIsolatedSpot(int nX, int nY);

protected:
	SDL_Surface	*m_pScreen;//Does not own
	SDL_Surface *m_pBackground;
#ifdef USE_GRAPHIC_YOU_WIN
	SDL_Surface 	*m_pWinGraphic;
#else
	YouWinMessage    m_YouWinMessage;
#endif
	nSDL_Font 	*m_pFont;
	HitoriLib	m_Hitori;
	int		m_nLevelNumber;
	Config		*m_pConfig;
	int		m_nCurrentX;
	int		m_nCurrentY;
	bool		m_bGameOver;
};

#endif
